grails-app/domain/gestionannonces/Annonce.groovy
package gestionannonces

class Annonce {

    String title
    String description
    Date  dateCreated
    Date validTill
    Boolean state   = Boolean.FALSE

    static belongsTo = [author:User]

    static hasMany = [illustrations:Illustration]

    static constraints = {
        title blank: false,nullable: false
        description blank: false,nullable: false
        validTill nullable: false
        illustrations nullable: true
    }

    @Override
    String toString() {
        return title
    }

}

grails-app/controllers/gestionannonces/AnnonceController.groovy
package gestionannonces

import grails.validation.ValidationException
import static org.springframework.http.HttpStatus.*

class AnnonceController {

    AnnonceService annonceService

    static allowedMethods = [save: "POST", update: "PUT", delete: "DELETE"]

    def index(Integer max) {
        params.max = Math.min(max ?: 10, 100)
        respond annonceService.list(params), model: [annonceCount: annonceService.count()]
    }

    def show(Long id) {
        respond annonceService.get(id)
    }

    def create() {
        respond new Annonce(params)
    }

    def save(Annonce annonce) {
        if (annonce == null) {
            notFound()
            return
        }

        try {


            def x = request.getFiles('illus')

            x.each{

                if (it == null || it.empty){
                    flash.message = "Veuillez saisir les illustrations"
                    return
                }else{

                    def pool = ['a'..'z','A'..'Z',0..9,'_'].flatten()
                    Random rand = new Random(System.currentTimeMillis())
                    def randomTab = (0..10).collect { pool[rand.nextInt(pool.size())] }

                    def randomString =""
                    for (item in randomTab) {
                        randomString = randomString + item
                    }

                    randomString =  randomString + ".png"

                    def File = new File (grailsApplication.config.maConfig.assets_url + randomString) // file de copy

                    if (File.exists()){
                        flash.message = "Fichier déjà existant"
                        return
                    }else{
                        it.transferTo(File)
                        annonce.addToIllustrations(new Illustration(filename: randomString))
                    }
                }



            }

            annonceService.save(annonce)

        } catch (ValidationException e) {
            respond annonce.errors, view: 'create'
            return
        }

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.created.message', args: [message(code: 'annonce.label', default: 'Annonce'), annonce.id])
                redirect annonce
            }
            '*' { respond annonce, [status: CREATED] }
        }
    }

    def edit(Long id) {
        respond annonceService.get(id)
    }

    def update(Annonce annonce) {
        if (annonce == null) {
            notFound()
            return
        }

        try {
            annonceService.save(annonce)
        } catch (ValidationException e) {
            respond annonce.errors, view: 'edit'
            return
        }

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.updated.message', args: [message(code: 'annonce.label', default: 'Annonce'), annonce.id])
                redirect annonce
            }
            '*' { respond annonce, [status: OK] }
        }
    }

    def delete(Long id) {
        if (id == null) {
            notFound()
            return
        }

        annonceService.delete(id)

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.deleted.message', args: [message(code: 'annonce.label', default: 'Annonce'), id])
                redirect action: "index", method: "GET"
            }
            '*' { render status: NO_CONTENT }
        }
    }

    protected void notFound() {
        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.not.found.message', args: [message(code: 'annonce.label', default: 'Annonce'), params.id])
                redirect action: "index", method: "GET"
            }
            '*' { render status: NOT_FOUND }
        }
    }

    def deleteIllustrationAnnonce() {
        try {
            def annonceInstance = Annonce.get(params.ann_id)
            def illustrationInstance = Illustration.get(params.illustration_id)
            annonceInstance.removeFromIllustrations(illustrationInstance)
            annonceInstance.save(flush : true)   // flush car on est pas en service

            // effacer le fichier physique

            // efface l'element physique

            def file = new File(grailsApplication.config.maConfig.assets_url + illustrationInstance.filename)

            if (file.exists()){
                file.delete()
            }

            illustrationInstance.delete(flush: true)

            redirect(controller: "annonce", action: "edit", id: annonceInstance.id)


        } catch (ValidationException e) {
            flash.message = "Une erreur est survenue"
            return
        }
    }
}

grails-app/views/annonce/create.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'annonce.label', default: 'Annonce')}" />
        <title><g:message code="default.create.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#create-annonce" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>
        <div id="create-annonce" class="content scaffold-create" role="main">
            <h1><g:message code="default.create.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
            </g:if>
            <g:hasErrors bean="${this.annonce}">
            <ul class="errors" role="alert">
                <g:eachError bean="${this.annonce}" var="error">
                <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message error="${error}"/></li>
                </g:eachError>
            </ul>
            </g:hasErrors>
            <g:form resource="${this.annonce}" method="POST" enctype="multipart/form-data">

%{--                <fieldset class="form">--}%
%{--                    <f:all bean="annonce"/>--}%
%{--                </fieldset>--}%


                <f:field bean="annonce" property="title"/>
                <f:field bean="annonce" property="description"/>
                <f:field bean="annonce" property="validTill"/>
                <f:field bean="annonce" property="author">
                    <select name="author"  id="author">
                        <g:each in="${gestionannonces.User.all}" var="user">
                            <option value="${user.id}">${user.username}</option>
                        </g:each>
                    </select>
                </f:field>
                <f:field bean="annonce" property="illustrations">
                    <input multiple="multiple" type="file" name="illus" accept="image/png" />
                </f:field>

                <br>

                <fieldset class="buttons">
                    <g:submitButton name="create" class="save" value="${message(code: 'default.button.create.label', default: 'Create')}" />
                </fieldset>
            </g:form>
        </div>
    </body>
</html>

grails-app/views/annonce/edit.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="main" />
    <g:set var="entityName" value="${message(code: 'annonce.label', default: 'Annonce')}" />
    <title><g:message code="default.edit.label" args="[entityName]" /></title>
</head>
<body>
<a href="#edit-annonce" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
<div class="nav" role="navigation">
    <ul>
        <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
        <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
        <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
    </ul>
</div>
<div id="edit-annonce" class="content scaffold-edit" role="main">
    <h1><g:message code="default.edit.label" args="[entityName]" /></h1>
    <g:if test="${flash.message}">
        <div class="message" role="status">${flash.message}</div>
    </g:if>
    <g:hasErrors bean="${this.annonce}">
        <ul class="errors" role="alert">
            <g:eachError bean="${this.annonce}" var="error">
                <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message error="${error}"/></li>
            </g:eachError>
        </ul>
    </g:hasErrors>
    <g:form resource="${this.annonce}" method="POST" enctype="multipart/form-data">
        <g:hiddenField name="version" value="${this.annonce?.version}" />

    %{--                <fieldset class="form">--}%
    %{--                    <f:all bean="annonce"/>--}%
    %{--                </fieldset>--}%

        <f:field bean="annonce" property="title"/>
        <f:field bean="annonce" property="description"/>
        <f:field bean="annonce" property="validTill"/>
%{--        <f:field property="state" bean="annonce"/>--}%

%{--        <f:field bean="annonce" property="author">--}%
%{--            <select name="author"  id="author">--}%
%{--                <g:each in="${gestionannonces.User.all}" var="user">--}%
%{--                    <option value="${user.id}">${user.username}</option>--}%
%{--                </g:each>--}%
%{--            </select>--}%
%{--        </f:field>--}%

        <f:field bean="annonce" property="illustrations">
            <input multiple="multiple" type="file" name="illus" accept="image/png" />
            <div class="property-value" aria-labelledby="illustrations-label">
                <g:each in="${annonce.illustrations}" var="illustrationsAnnonce">
                    <br><br>
                    <g:img width="100" src="${illustrationsAnnonce.filename}" />

                    <g:link controller="annonce" action="deleteIllustrationAnnonce"
                            params="[ann_id: annonce.id ,
                                     illustration_id : illustrationsAnnonce.id]"> delete </g:link>
                </g:each>
            </div>
        </f:field>

        <br>

        <fieldset class="buttons">
            <input class="save" type="submit" value="${message(code: 'default.button.update.label', default: 'Update')}" />
        </fieldset>
    </g:form>
</div>
</body>
</html>

grails-app/views/annonce/index.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="main" />
    <g:set var="entityName" value="${message(code: 'annonce.label', default: 'Annonce')}" />
    <title><g:message code="default.list.label" args="[entityName]" /></title>
</head>
<body>
<a href="#list-annonce" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
<div class="nav" role="navigation">
    <ul>
        <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
        <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
    </ul>
</div>
<div id="list-annonce" class="content scaffold-list" role="main">
    <h1><g:message code="default.list.label" args="[entityName]" /></h1>
    <g:if test="${flash.message}">
        <div class="message" role="status">${flash.message}</div>
    </g:if>



%{--    <f:table collection="${annonceList}" />--}%


    <table>
        <thead>
        <tr>
            <th class="sortable" ><a href="/annonce/index?sort=title&amp;max=10&amp;order=asc">Title</a></th>
            <th class="sortable" ><a href="/annonce/index?sort=description&amp;max=10&amp;order=asc">Description</a></th>
            <th class="sortable" ><a href="/annonce/index?sort=validTill&amp;max=10&amp;order=asc">Date validitée</a></th>
            <th class="sortable" >Nbr Illustrations</th>
            <th class="sortable" >Etat</th>
            <th class="sortable" ><a href="/annonce/index?sort=author&amp;max=10&amp;order=asc">Author</a></th>

        </tr>
        </thead>
        <tbody>

        <g:each in="${annonceList}" var="annonce" status="i">
            <tr class="${ (i%2) == 0 ? 'even' : 'odd' }">
                <td>
                    <g:link controller="annonce" action="show" id="${annonce.id}">
                        ${annonce.title}
                    </g:link>
                </td>
                <td>${annonce.description}</td>
                <td><g:formatDate date="${annonce.validTill}" type="datetime" style="medium" /></td>
                <td>

                    <g:each in="${annonce.illustrations}" var="ill">
                        <g:link controller="illustration" action="show" id="${ill.id}">
                            <g:img width="50" file="${ill.filename}"/> <br>
                        </g:link>
                    </g:each>

                </td>
                <td>
                    <g:if test="${annonce.state == true}">
                        Validée
                    </g:if>
                    <g:else>
                        Non validée
                    </g:else>
                </td>
                <td>
                    <g:link controller="user" action="show" id="${annonce.author.id}">
                        ${annonce.author.username}
                    </g:link>
                </td>
            </tr>
        </g:each>

        </tbody>
    </table>

    <div class="pagination">
        <g:paginate total="${annonceCount ?: 0}" />
    </div>
</div>
</body>
</html>

grails-app/views/annonce/show.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="main" />
    <g:set var="entityName" value="${message(code: 'annonce.label', default: 'Annonce')}" />
    <title><g:message code="default.show.label" args="[entityName]" /></title>
</head>
<body>
<a href="#show-annonce" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
<div class="nav" role="navigation">
    <ul>
        <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
        <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
        <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
    </ul>
</div>
<div id="show-annonce" class="content scaffold-show" role="main">
    <h1><g:message code="default.show.label" args="[entityName]" /></h1>
    <g:if test="${flash.message}">
        <div class="message" role="status">${flash.message}</div>
    </g:if>


%{--            <f:display bean="annonce" />--}%

    <ol class="property-list annonce">

        <li class="fieldcontain">
            <span id="title-label" class="property-label">Title</span>
            <div class="property-value" aria-labelledby="title-label">
                ${annonce.title}
            </div>
        </li>

        <li class="fieldcontain">
            <span id="description-label" class="property-label">Description</span>
            <div class="property-value" aria-labelledby="description-label">
                ${annonce.description}
            </div>
        </li>

        <li class="fieldcontain">
            <span id="validTill-label" class="property-label">Date Validitée</span>
            <div class="property-value" aria-labelledby="validTill-label">
                <g:formatDate date="${annonce.validTill}" type="datetime" style="medium" />
            </div>
        </li>

        <li class="fieldcontain">
            <span id="illustrations-label" class="property-label">Illustrations</span>
            <div class="property-value" aria-labelledby="illustrations-label">

                <table>
                    <g:each in="${annonce.illustrations}" var="ill" status="i">

                        <g:if  test="${i % 2 == 0}" >
                            <tr>
                            <td>
                            <g:link controller="illustration" action="show"  id="${ill.id}">
                                <g:img width="100" file="${ill.filename}" />
                            </g:link>
                            </td>
                        </g:if>


                        <g:else>
                            <td>
                                <g:link controller="illustration" action="show"  id="${ill.id}">
                                    <g:img width="100" file="${ill.filename}" />
                                </g:link>
                            </td>
                            </tr>
                        </g:else>
                    </g:each>
                </table>

            </div>
        </li>

        <li class="fieldcontain">
            <span id="state-label" class="property-label">Etat</span>
            <div class="property-value" aria-labelledby="state-label">
                <g:if test="${annonce.state == true}">
                    Validée
                </g:if>
                <g:else>
                    Non Validée
                </g:else>
            </div>
        </li>

        <li class="fieldcontain">
            <span id="author-label" class="property-label">Author</span>
            <div class="property-value" aria-labelledby="author-label">
                <g:link controller="user" action="show" id="${annonce.author.id}">
                    ${annonce.author.username}
                </g:link>
            </div>
        </li>

    </ol>



    <g:form resource="${this.annonce}" method="DELETE">
        <fieldset class="buttons">
            <g:link class="edit" action="edit" resource="${this.annonce}"><g:message code="default.button.edit.label" default="Edit" /></g:link>
            <input class="delete" type="submit" value="${message(code: 'default.button.delete.label', default: 'Delete')}" onclick="return confirm('${message(code: 'default.button.delete.confirm.message', default: 'Are you sure?')}');" />
        </fieldset>
    </g:form>
</div>
</body>
</html>